SystemOrganization addCategory: #'Magritte-Core'!
SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Accessor'!
SystemOrganization addCategory: #'Magritte-Core-Memento'!
SystemOrganization addCategory: #'Magritte-Core-Relation'!
SystemOrganization addCategory: #'Magritte-Core-Command'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Exception'!
SystemOrganization addCategory: #'Magritte-Core-Utility'!

SmaCCScanner subclass: #MARelationScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelationScanner class methodsFor: 'generated-initialization' stamp: 'lr 6/2/2005 12:01'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(10 'AND' 4) #(10 'NOT' 1) #(10 'OR' 5) #(10 'false' 6) #(10 'nil' 2) #(10 'true' 7)) 
		do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!MARelationScanner class methodsFor: 'generated-comments' stamp: 'lr 6/2/2005 12:01'!
scannerDefinitionComment

	"<unary>			: [a-zA-Z] [a-zA-Z0-9]* ;
<number>		: [\-]? [0-9] [0-9]* ;
<string>			: \' [^\']* \' (\' [^\']* \')* ;
<keyword>		: <unary> \: ;
<binary>		: [\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]? ;
<whitespace>		: \s+ ;
<comment>		: \"" [^\""]* \"" ;"! !

!MARelationScanner methodsFor: 'generated-tokens' stamp: 'lr 6/2/2005 12:01'!
emptySymbolTokenId
	^30! !

!MARelationScanner methodsFor: 'generated-tokens' stamp: 'lr 6/2/2005 12:01'!
errorTokenId
	^31! !

!MARelationScanner methodsFor: 'generated-scanner' stamp: 'lr 6/2/2005 12:01'!
scan1
	
	[
	[self step.
	currentCharacter ~~ $'] whileTrue.
	self recordMatch: #(12).
	self step.
	currentCharacter == $'] 
			whileTrue: [].
	^self reportLastMatch! !

!MARelationScanner methodsFor: 'generated-scanner' stamp: 'lr 6/2/2005 12:01'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[
				[self recordMatch: #(10).
				self step.
				currentCharacter isDigit or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]] 
						whileTrue.
				currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(13)].
				^self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[(currentCharacter between: $< and: $@) or: 
											[currentCharacter == $\ 
												or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(14).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(14)].
			^self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(11).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[
			[self recordMatch: #whitespace.
			self step.
			currentCharacter isSeparator or: [currentCharacter == $]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[
			[self step.
			currentCharacter ~~ $"] whileTrue.
			^self recordAndReportMatch: #comment].
	currentCharacter == $' ifTrue: [^self scan1].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(3 14).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(14)].
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(11).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

Error subclass: #MAError
	instanceVariableNames: 'memento resumable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MAConcurrentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MAError class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
memento: aMemento message: aString
	^ self memento: aMemento message: aString resumable: false.! !

!MAError class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
memento: aMemento message: aString resumable: aBoolean
	^ self new
		memento: aMemento;
		resumable: aBoolean;
		signal: aString.! !

!MAError methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:31'!
accessor
	^ self memento accessor.! !

!MAError methodsFor: 'accessing-dynamic' stamp: 'lr 5/9/2005 13:31'!
description
	^ self memento description.! !

!MAError methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isResumable
	^ self resumable.! !

!MAError methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
memento
	^ memento! !

!MAError methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
memento: aMemento
	memento := aMemento! !

!MAError methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
resumable
	^ resumable! !

!MAError methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
resumable: aBoolean
	resumable := aBoolean! !

MAError subclass: #MAReadonlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

Object subclass: #MABlockToRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MABlockToRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
do: aBlock
	^ aBlock value: self new.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
< anObject
	^ MASelectorRelation selector: #< with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
<= anObject
	^ MASelectorRelation selector: #<= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ MASelectorRelation selector: #= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
> anObject
	^ MASelectorRelation selector: #> with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
>= anObject
	^ MASelectorRelation selector: #>= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
beginsWith: anObject
	^ MASelectorRelation selector: #beginsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
between: aMinimum and: aMaximum 
	^ MASelectorRelation selector: #between:and: with: aMinimum with: aMaximum.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
endsWith: anObject
	^ MASelectorRelation selector: #endsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 5/9/2005 10:07'!
hash
	^ self shouldNotImplement.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
includes: anObject
	^ MASelectorRelation selector: #includes: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
isEmpty
	^ MASelectorRelation selector: #isEmpty.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isEven
	^ MASelectorRelation selector: #even.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isFloat
	^ MASelectorRelation selector: #isFloat.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isInteger
	^ MASelectorRelation selector: #isInteger.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isNegative
	^ MASelectorRelation selector: #negative.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 5/8/2005 20:29'!
isNil
	^ MASelectorRelation selector: #isNil.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isOdd
	^ MASelectorRelation selector: #odd.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isPositive
	^ MASelectorRelation selector: #positive.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isZero
	^ MASelectorRelation selector: #isZero.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
matches: anObject
	^ MASelectorRelation selector: #matches:.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
notEmpty
	^ MASelectorRelation selector: #notEmpty.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 5/8/2005 20:29'!
notNil
	^ MASelectorRelation selector: #notNil.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
~= anObject
	^ MASelectorRelation selector: #~= with: anObject.! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
default
	default isNil
		ifTrue: [ default := self new ].
	^ default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
build: anObject
	| description |
	^ anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each) ifTrue: [ 
				description := anObject perform: each.
				description isDescription
					ifTrue: [ container add: description ] ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isDescriptionSelector: aSelector
	^ aSelector notNil
		and: [ aSelector isUnary ]
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
build: anObject
	^ self cache
		at: anObject
		ifAbsentPut: [ super build: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
cache
	^ cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
initialize
	super initialize.
	self flush; register.! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 5/8/2005 20:29'!
modified: anEvent
	(self isDescriptionSelector: anEvent itemSelector) 
		ifTrue: [ self flush ].! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 5/8/2005 20:29'!
register
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #modified:.! !

Object subclass: #MAObject
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core'!

MAObject subclass: #MAAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ self species = anObject species.! !

!MAAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canRead
	^ true! !

!MAAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canWrite
	^ true! !

!MAAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
hash
	^ self species hash.! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printOn: aStream
	super printOn: aStream.
	self canRead ifTrue: [
		aStream nextPutAll: ' read: {'.
		self printRead: 'aModel' on: aStream.
		aStream nextPutAll: '}' ].
	self canWrite ifTrue: [
		aStream nextPutAll: ' write: {'.
		self printWrite: 'anObject' to: 'aModel' on: aStream.
		aStream nextPutAll: '}' ].! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream! !

!MAAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
read: aModel
	"Read from aModel using the description of the receiver."
	
	self subclassResponsibility.! !

!MAAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
write: anObject to: aModel
	"Write to aModel using the description of the receiver and anObject as value."
	
	self subclassResponsibility.! !

MAAccessor subclass: #MABlockAccessor
	instanceVariableNames: 'readBlock writeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MABlockAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MABlockAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock
	^ self new
		readBlock: aReadBlock;
		writeBlock: aWriteBlock;
		yourself.! !

!MABlockAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ super = anObject
		and: [ self readBlock = anObject readBlock ]
		and: [ self writeBlock = anObject writeBlock ].! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canRead
	^ self readBlock notNil.! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canWrite
	^ self writeBlock notNil.! !

!MABlockAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
hash
	^ (self readBlock hash bitXor: self writeBlock hash)
		bitXor: super hash.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printBlock: aBlock on: aStream
	aStream nextPutAll: aBlock decompile asString allButFirst allButLast.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream
	self printBlock: self readBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream
	self printBlock: self writeBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.
	aStream nextPutAll: ' value: '; nextPutAll: anObject asString.! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
read: aModel
	^ self readBlock value: aModel.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
readBlock
	^ readBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
readBlock: aBlock
	readBlock := aBlock! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
write: anObject to: aModel
	self writeBlock value: aModel value: anObject.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
writeBlock
	^ writeBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
writeBlock: aBlock
	writeBlock := aBlock! !

MAAccessor subclass: #MACascadeAccessor
	instanceVariableNames: 'accessor next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor next: aNextAccessor
	^ self new
		accessor: anAccessor;
		next: aNextAccessor; 
		yourself.! !

!MACascadeAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray
	^ anArray allButLast reverse
		inject: (MASelectorAccessor selector: anArray last)
		into: [ :next :accessor | 
			self 
				accessor: (MASelectorAccessor selector: accessor)
				next: next ].! !

!MACascadeAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ super = anObject
		and: [ self accessor = anObject accessor ]
		and: [ self next = anObject next ].! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor
	^ accessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor: anAccessor
	accessor := anAccessor! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canRead
	^ self next canRead.! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canWrite
	^ self next canWrite.! !

!MACascadeAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
hash
	^ (self accessor hash bitXor: self next hash)
		bitXor: super hash.! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
next
	^ next! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
next: anAccessor
	next := anAccessor! !

!MACascadeAccessor methodsFor: 'copying' stamp: 'lr 5/8/2005 20:29'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self next: self next copy.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream
	self next 
		printRead: (String streamContents: [ :stream |
			self accessor 
				printRead: aModel 
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream
	self next
		printWrite: anObject
		to: (String streamContents: [ :stream |
			self accessor
				printRead: aModel
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
read: aModel
	^ self next read: (self accessor read: aModel).! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
write: anObject to: aModel
	self next write: anObject to: (self accessor read: aModel).! !

MAAccessor subclass: #MAContainerAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAContainerAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAContainerAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
canWrite
	^ false! !

!MAContainerAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:30'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:30'!
read: aModel
	^ aModel.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:30'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAAccessor subclass: #MANullAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MANullAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
canRead
	^ false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
canWrite
	^ false! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:31'!
read: aModel
	self error: 'Not supposed to read from ' , aModel asString , '.'.! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:31'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAAccessor subclass: #MASelectorAccessor
	instanceVariableNames: 'readSelector writeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MASelectorAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
read: aReadSelector write: aWriteSelector
	^ self new
		readSelector: aReadSelector;
		writeSelector: aWriteSelector;
		yourself.! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector
	^ self new
		selector: aSelector;
		yourself.! !

!MASelectorAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:32'!
= anObject
	^ super = anObject
		and: [ self readSelector = anObject readSelector ]
		and: [ self writeSelector = anObject writeSelector ].! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
canRead
	^ self readSelector notNil.! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
canWrite
	^ self writeSelector notNil.! !

!MASelectorAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:32'!
hash
	^ (self readSelector hash bitXor: self writeSelector hash)
		bitXor: super hash.! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:32'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self readSelector.! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:32'!
printWrite: anObject to: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self writeSelector; space.
	aStream nextPutAll: anObject asString.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:32'!
read: aModel
	^ aModel perform: self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
readSelector
	^ readSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
readSelector: aSelector
	readSelector := aSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
selector
	^ self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
selector: aSelector
	self readSelector: aSelector asSymbol.
	self writeSelector: (aSelector copyWith: $:) asSymbol.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:32'!
write: anObject to: aModel
	aModel perform: self writeSelector with: anObject.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
writeSelector
	^ writeSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
writeSelector: aSelector
	writeSelector := aSelector.! !

MAAccessor subclass: #MAVariableAccessor
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAVariableAccessor class methodsFor: 'testing' stamp: 'lr 5/9/2005 13:43'!
isAbstract
	^ false! !

!MAVariableAccessor class methodsFor: 'instance creation' stamp: 'lr 5/9/2005 13:43'!
name: aString
	^ self new
		name: aString;
		yourself.! !

!MAVariableAccessor methodsFor: 'comparing' stamp: 'lr 5/9/2005 13:38'!
= anObject
	^ super = anObject
		and: [ self name = anObject name ].! !

!MAVariableAccessor methodsFor: 'comparing' stamp: 'lr 5/9/2005 13:38'!
hash
	^ super hash bitXor: self name hash.! !

!MAVariableAccessor methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:37'!
name
	^ name! !

!MAVariableAccessor methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:37'!
name: aString
	name := aString! !

!MAVariableAccessor methodsFor: 'printing' stamp: 'lr 5/9/2005 13:42'!
printRead: aModel on: aStream
	aStream 
		nextPutAll: aModel asString;
		nextPutAll: ' instVarNamed: '; print: self name.! !

!MAVariableAccessor methodsFor: 'printing' stamp: 'lr 5/9/2005 13:42'!
printWrite: anObject to: aModel on: aStream
	aStream 
		nextPutAll: aModel asString; 
		nextPutAll: ' instVarNamed: '; print: self name;
		nextPutAll: ' put: '; nextPutAll: anObject.! !

!MAVariableAccessor methodsFor: 'model' stamp: 'lr 5/9/2005 13:38'!
read: aModel
	^ aModel instVarNamed: self name.! !

!MAVariableAccessor methodsFor: 'model' stamp: 'lr 5/9/2005 13:39'!
write: anObject to: aModel
	aModel instVarNamed: self name put: anObject.! !

MAObject subclass: #MACommand
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Command'!

MACommand subclass: #MABlockCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Command'!

!MACommand methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor
	accessor isNil
		ifTrue: [ self accessor: self class defaultAccessor ].
	^ accessor.! !

!MACommand methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor: anAccessor	
	accessor := anAccessor! !

!MACommand methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
comment	
	^ self propertyAt: #comment ifAbsent: [ self class defaultComment ].! !

!MACommand methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MACommand methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
execute
	self subclassResponsibility.! !

!MACommand methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
label	
	^ self propertyAt: #label ifAbsent: [ self class defaultLabel ].! !

!MACommand methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:29'!
label: aString
	self propertyAt: #label put: aString.! !

MACommand subclass: #MASendCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Command'!

MAObject subclass: #MADescription
	instanceVariableNames: 'hash accessor default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer commentStamp: 'lr 5/5/2005 10:12' prior: 0!
A container is a composition of different descriptions, that fully supports the collection protocol.!

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultAccessor
	^ MAContainerAccessor new.! !

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultCollection
	^ OrderedCollection new.! !

!MAContainer class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aDescription
	^ self new
		add: aDescription;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
withAll: aCollection
	^ self new
		addAll: aCollection;
		yourself.! !

!MAContainer methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	^ super = anObject
		and: [ self children = anObject children ].! !

!MAContainer methodsFor: 'visiting' stamp: 'lr 5/8/2005 20:30'!
acceptMagritte: aVisitor
	aVisitor visitContainer: self.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 5/8/2005 20:30'!
add: aDescription
	self children add: aDescription.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 5/8/2005 20:30'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'converting' stamp: 'lr 5/8/2005 20:30'!
asContainer
	^ self! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
at: anIndex
	^ self children at: anIndex.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
at: anIndex ifAbsent: aBlock
	^ self children at: anIndex ifAbsent: aBlock.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
children
	^ children! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
collect: aBlock
	^ self copy 
		setChildren: (self children collect: aBlock);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
copyFrom: aStartIndex to: anEndIndex
	^ self copy 
		setChildren: (self children
			copyFrom: aStartIndex 
			to: anEndIndex);
		yourself.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
detect: aBlock 
	^ self children detect: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
detect: aBlock ifNone: anExceptionBlock 
	^ self children detect: aBlock ifNone: anExceptionBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
do: aBlock separatedBy: aSeparatorBlock
	self children do: aBlock separatedBy: aSeparatorBlock.! !

!MAContainer methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
errorNotFound: aDescription
	self error: aDescription asLabel , ' not found.'.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasChildren
	^ self notEmpty.! !

!MAContainer methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
hash
	^ super hash bitXor: self children hash.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
includes: aDescription
	^ self children includes: aDescription.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
initialize
	super initialize.
	self setChildren: self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
inject: anObject into: aBlock 
	^ self children inject: anObject into: aBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isContainer	
	^ true! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isEmpty
	^ self children isEmpty.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:30'!
moveDown: aDescription
	self children moveDown: aDescription.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:30'!
moveUp: aDescription
	self children moveUp: aDescription.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
notEmpty
	^ self children notEmpty.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
postCopy
	super postCopy.
	self setChildren: self children copy.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
reject: aBlock
	^ self copy 
		setChildren: (self children reject: aBlock);
		yourself.! !

!MAContainer methodsFor: 'removing' stamp: 'lr 5/8/2005 20:30'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ self errorNotFound: aDescription ].! !

!MAContainer methodsFor: 'removing' stamp: 'lr 5/8/2005 20:30'!
removeAll
	children := self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
select: aBlock
	^ self copy 
		setChildren: (self children select: aBlock);
		yourself.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setChildren: aCollection
	children := aCollection! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
size
	^ self children size.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
with: aCollection do: aBlock
	self children with: aCollection do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
withIndexDo: aBlock
	self children withIndexDo: aBlock.! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPriorityContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultCollection
	^ SortedCollection new.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:31'!
moveDown: aDescription
	aDescription priority: aDescription priority - 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:31'!
moveUp: aDescription
	aDescription priority: aDescription priority + 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
resort
	self setChildren: self children copy.! !

MAContainer subclass: #MAReportContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:33'!
defaultCaption
	^ nil! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:34'!
defaultEmpty
	^ 'The report is empty.'! !

!MAReportContainer class methodsFor: 'accessing-defaults-batch' stamp: 'lr 5/8/2005 20:33'!
defaultPageSize
	^ 10! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultShowBatch
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultShowFooter
	^ false! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultShowHeader
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:34'!
defaultSummary
	^ nil! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
descriptionCaption
	^ MAStringDescription selector: #caption label: 'Caption' priority: 1000 default: self defaultCaption.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:34'!
descriptionEmpty
	^ MAStringDescription selector: #empty label: 'Empty' priority: 1200 default: self defaultEmpty.! !

!MAReportContainer class methodsFor: 'accessing-description-batch' stamp: 'lr 5/8/2005 20:34'!
descriptionPageSize
	^ MANumberDescription selector: #pageSize label: 'Page Size' priority: 2000 default: self defaultPageSize.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionShowBatch
	^ MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 3200 default: self defaultShowBatch.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionShowFooter
	^ MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 3100 default: self defaultShowFooter.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionShowHeader
	^ MABooleanDescription selector: #showHeader label: 'Show Header' priority: 3000 default: self defaultShowHeader.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:34'!
descriptionSummary
	^ MAStringDescription selector: #summary label: 'Summary' priority: 1100 default: self defaultSummary.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
caption
	^ self propertyAt: #caption ifAbsent: [ self class defaultCaption ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
caption: aString
	self propertyAt: #caption put: aString.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
empty
	^ self propertyAt: #empty ifAbsent: [ self class defaultEmpty ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
empty: aString
	self propertyAt: #empty put: aString.! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 5/8/2005 20:32'!
pageSize
	^ self propertyAt: #pageSize ifAbsent: [ self class defaultPageSize ].! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 5/8/2005 20:32'!
pageSize: aNumber
	self propertyAt: #pageSize put: aNumber.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showBatch
	^ self propertyAt: #showBatch ifAbsent: [ self class defaultShowBatch ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showFooter
	^ self propertyAt: #showFooter ifAbsent: [ self class defaultShowFooter ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showHeader
	^ self propertyAt: #showHeader ifAbsent: [ self class defaultShowHeader ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
summary
	^ self propertyAt: #summary ifAbsent: [ self class defaultSummary ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
summary: aString
	self propertyAt: #summary put: aString.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor
	^ self accessor: anAccessor label: self defaultLabel.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString
	^ self accessor: anAccessor label: aString priority: self defaultPriority.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString priority: aNumber
	^ self accessor: anAccessor label: aString priority: aNumber default: self defaultDefault.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString priority: aNumber default: anObject
	^ self new
		accessor: anAccessor;
		label: aString;
		priority: aNumber;
		default: anObject;
		yourself.! !

!MADescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ super asLabel allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultAccessor
	^ MANullAccessor new.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultComment
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultCondition
	^ MAConstantRelation true.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultDefault
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultLabel
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultPersistent
	^ true! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultPriority
	^ 0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultReadonly
	^ false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultRequired
	^ false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultVisible
	^ true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionComment
	^ MATextDescription selector: #comment label: 'Comment' priority: 110 default: self defaultComment.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionDefault
	^ self isAbstract 
		ifFalse: [ self selector: #default label: 'Default' priority: 200 default: self defaultDefault ].! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionLabel
	^ MAStringDescription selector: #label label: 'Label' priority: 100 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionPersistent
	^ MABooleanDescription selector: #persistent label: 'Persistent' priority: 330 default: self defaultPersistent.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionPriority
	^ MANumberDescription selector: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionReadonly
	^ MABooleanDescription selector: #readonly label: 'Readonly' priority: 300 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionRequired
	^ MABooleanDescription selector: #required label: 'Required' priority: 320 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionVisible
	^ MABooleanDescription selector: #visible label: 'Visible' priority: 310 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ true! !

!MADescription class methodsFor: 'instance-creation' stamp: 'lr 5/8/2005 20:33'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock).! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber default: anObject
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector
	^ self accessor: (MASelectorAccessor selector: aSelector).! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString priority: aNumber
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString priority: aNumber default: anObject
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray
	^ self accessor: (MACascadeAccessor selectors: anArray).! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString priority: aNumber
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString priority: aNumber default: anObject
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber default: anObject.! !

!MADescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:30'!
, aDescription
	"Merge the receiver and aDescription to one composed description"

	^ self asContainer copy
		addAll: aDescription asContainer;
		yourself.! !

!MADescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:30'!
<= anObject
	"Answer whether the receiver should precede anObject in a priority container."
	
	^ self priority <= anObject priority.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	"Compare the receiver with the argument and answer with true if the receiver is equal to the argument. Note that this test doesn't necessarily give back the right results, but presumably in most cases it does."

	^ super = anObject 
		or: [ self isSameAs: anObject ].! !

!MADescription methodsFor: 'visiting' stamp: 'lr 5/8/2005 20:30'!
acceptMagritte: aVisitor
	aVisitor visitDescription: self.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
accessor
	accessor isNil
		ifTrue: [ self accessor: self class defaultAccessor ].
	^ accessor.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
accessor: anAccessor	
	accessor := anAccessor! !

!MADescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:30'!
asContainer
	self subclassResponsibility.! !

!MADescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:30'!
asLabel
	^ self label ifNil: [ super asLabel ].! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beEphemeral
	self persistent: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
bePersistent
	self persistent: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
comment	
	^ self propertyAt: #comment ifAbsent: [ self class defaultComment ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
condition	
	^ self propertyAt: #condition ifAbsent: [ self class defaultCondition ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
condition: aCondition
	self propertyAt: #condition put: ((aCondition isKindOf: BlockContext)
		ifTrue: [ MABlockToRelation do: aCondition ]
		ifFalse: [ aCondition ]).! !

!MADescription methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
copyInto: aDictionary
	^ aDictionary at: self put: self copy.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
default
	^ default! !

!MADescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
default: anObject
	default := anObject! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasChildren
	^ false! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasComment
	^ (self propertyAt: #comment ifAbsent: [ ^ false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasCondition
	^ self propertyAt: #condition ifAbsent: [ ^ false ].! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasLabel
	^ (self propertyAt: #label ifAbsent: [ ^ false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
hash
	^ hash bitXor: self accessor hash.! !

!MADescription methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
initialize
	super initialize.
	self initializeHash.! !

!MADescription methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
initializeHash
	self setHash: SmallInteger maxVal atRandom.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isContainer	
	^ false! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isDescription
	^ true! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isPersistent
	^ self persistent.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isReadonly
	^ self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isRequired
	^ self required.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
isSameAs: anObject
	"Return true if the receiver and anObject are of the same type and share the same hash. In this case the two objects are presumably the same."
	
	^ self species = anObject species
		and: [ self hash = anObject hash ]
		and: [ self accessor = anObject accessor ].! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isSatisfiedBy: anObject
	"Return true or false wheter anObject is a proper value of the receiver."

	^ (anObject isKindOf: self kind)
		and: [ self condition isSatisfiedBy: anObject ].! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isVisible
	^ self visible.! !

!MADescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
key
	^ [ self accessor selector ]
		on: Error
		do: [ :err | nil ].! !

!MADescription methodsFor: 'accessing-configuration' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Object! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
label	
	^ self propertyAt: #label ifAbsent: [ self class defaultLabel ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
label: aString
	self propertyAt: #label put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
persistent	
	^ self propertyAt: #persistent ifAbsent: [ self class defaultPersistent ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
persistent: aBoolean
	self propertyAt: #persistent put: aBoolean.! !

!MADescription methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self default: self default copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 5/8/2005 20:30'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $[; print: self hash; nextPut: $].
	aStream nextPutAll: ' label: '; print: self label.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
priority
	^ self propertyAt: #priority ifAbsent: [ self class defaultPriority ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
priority: aNumber
	self propertyAt: #priority put: aNumber.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
readonly	
	^ self propertyAt: #readonly ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
required	
	^ self propertyAt: #required ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setHash: anInteger
	hash := anInteger! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
visible	
	^ self propertyAt: #visible ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElementDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElementDescription subclass: #MABinaryDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABinaryDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Upload'! !

!MABinaryDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MABinaryDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
kind
	^ ByteArray! !

!MABinaryDescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:29'!
parseString: aString
	^ self parseString: aString protected: [ ByteArray withAll: aString ].! !

MAElementDescription subclass: #MABooleanDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABooleanDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Check-Box'! !

!MABooleanDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABooleanDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
kind
	^ Boolean! !

!MABooleanDescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:29'!
parseString: aString
	^ self parseString: aString protected: [
		(self trueStrings includes: aString)
			ifTrue: [ ^ true ].
		(self falseStrings includes: aString)
			ifTrue: [ ^ false ].
		aString ].! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

!MAElementDescription methodsFor: 'visiting' stamp: 'lr 5/8/2005 20:31'!
acceptMagritte: aVisitor
	aVisitor visitElement: self.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:31'!
asContainer
	^ MAContainer with: self.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
collectionToString: aCollection
	^ String streamContents: [ :stream |
		aCollection
			do: [ :each | stream nextPutAll: (self toString: each) ]
			separatedBy: [ stream cr ] ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
parseString: aString
	^ self parseString: aString protected: [ aString asString ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
parseString: aString protected: aBlock
	^ aString isEmptyOrNil ifFalse: [ 
		aBlock
			on: Error
			do: [ :err | err return: aString ] ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
stringToCollection: aString default: aCollection
	^ aString isEmptyOrNil
		ifTrue: [ aCollection ]
		ifFalse: [
			(((aString findTokens: Character cr)
				collect: [ :each | each withBlanksCondensed ])
					select: [ :each | each notEmpty ])
						collect: [ :each | self parseString: each ] ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
toString: anObject
	^ anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asLabel ].! !

MAElementDescription subclass: #MAMagnitudeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAMagnitudeDescription subclass: #MADateDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADateDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Date Field'! !

!MADateDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MADateDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Date! !

MAMagnitudeDescription subclass: #MADurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADurationDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Duration Field'! !

!MADurationDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MADurationDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Duration! !

!MAMagnitudeDescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:31'!
parseString: aString
	^ self parseString: aString protected: [ self kind fromString: aString ].! !

MAMagnitudeDescription subclass: #MANumberDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumberDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Number Field'! !

!MANumberDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANumberDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
kind
	^ Number! !

!MANumberDescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:31'!
parseString: aString
	^ self parseString: aString protected: [ aString asNumber ].! !

MAMagnitudeDescription subclass: #MATimeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Time Field'! !

!MATimeDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATimeDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
kind
	^ Time! !

MAMagnitudeDescription subclass: #MATimeStampDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeStampDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Timestamp Field'! !

!MATimeStampDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATimeStampDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
kind
	^ TimeStamp! !

MAElementDescription subclass: #MASelectionDescription
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MASelectionDescription subclass: #MAMultipleSelectionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAMultipleSelectionDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Multiple-Selection'! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultAvailableLabel
	^ 'Available'! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 6/7/2005 21:12'!
defaultEverything
	^ false! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultOrdered
	^ true! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultSelectedLabel
	^ 'Selected'! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultUnique
	^ true! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionAvailableLabel
	^ MAStringDescription selector: #availableLabel label: 'Available Label' priority: 380.! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 6/7/2005 21:13'!
descriptionEverything
	^ MABooleanDescription selector: #everything label: 'Everything' priority: 480.! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionOrdered
	^ MABooleanDescription selector: #ordered label: 'Ordered' priority: 470.! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionSelectedLabel
	^ MAStringDescription selector: #selectedLabel label: 'Selected Label' priority: 390.! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionUnique
	^ MABooleanDescription selector: #unique label: 'Unique' priority: 460.! !

!MAMultipleSelectionDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
add: anObject to: aCollection
	anObject isNil
		ifTrue: [ ^ self ].
	(self isUnique and: [ aCollection includes: anObject ])
		ifTrue: [ ^ self ]. 
	aCollection add: anObject.! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:31'!
availableLabel
	^ self propertyAt: #availableLabel ifAbsent: [ self class defaultAvailableLabel ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:31'!
availableLabel: aString
	^ self propertyAt: #availableLabel put: aString.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
beMultiple
	self unique: false.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
beOrdered
	self ordered: true.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
beUnique
	self unique: true.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
beUnordered
	self ordered: false.! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 6/7/2005 21:12'!
everything
	^ self propertyAt: #everything ifAbsent: [ self class defaultEverything ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 6/7/2005 21:12'!
everything: aBoolean
	^ self propertyAt: #everything put: aBoolean.! !

!MAMultipleSelectionDescription methodsFor: 'testing' stamp: 'lr 6/7/2005 21:12'!
isEverything
	^ self everything.! !

!MAMultipleSelectionDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isOrdered
	^ self ordered.! !

!MAMultipleSelectionDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject) and: [ 
		anObject allSatisfy: [ :each | 
			self options includes: each ] ].! !

!MAMultipleSelectionDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isUnique
	^ self unique.! !

!MAMultipleSelectionDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
kind
	^ Collection! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:31'!
ordered
	^ self propertyAt: #ordered ifAbsent: [ self class defaultOrdered ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:31'!
ordered: aBoolean
	^ self propertyAt: #ordered put: aBoolean.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
remove: anObject from: aCollection
	anObject isNil
		ifTrue: [ ^ self ].
	aCollection remove: anObject ifAbsent: nil.! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:31'!
selectedLabel
	^ self propertyAt: #selectedLabel ifAbsent: [ self class defaultSelectedLabel ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:31'!
selectedLabel: aString
	^ self propertyAt: #selectedLabel put: aString.! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:31'!
unique
	^ self propertyAt: #unique ifAbsent: [ self class defaultUnique ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:31'!
unique: aBoolean
	^ self propertyAt: #unique put: aBoolean.! !

!MASelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultOptions
	^ OrderedCollection new.! !

!MASelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultSorted
	^ false! !

!MASelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionDefault
	^ nil! !

!MASelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionOptions
	^ MATextDescription selector: #optionsTextual label: 'Options' priority: 400.! !

!MASelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionSorted
	^ MABooleanDescription selector: #sorted label: 'Sorted' priority: 450.! !

!MASelectionDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
allOptions
	^ Array streamContents: [ :stream |
		self isSorted
			ifFalse: [ stream nextPutAll: self options ]
			ifTrue: [ 
				stream nextPutAll: (self options asSortedCollection: [ :a :b | 
					(a asLabel compare: b asLabel) <= 2 ]) ] ].! !

!MASelectionDescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
beSorted
	self sorted: true.! !

!MASelectionDescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:32'!
beUnsorted
	self sorted: false.! !

!MASelectionDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSorted
	^ self sorted.! !

!MASelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
options
	^ options ifNil: [ options := self class defaultOptions ].! !

!MASelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
options: aCollection
	options := aCollection! !

!MASelectionDescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:32'!
optionsTextual
	^ self collectionToString: self options.! !

!MASelectionDescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:32'!
optionsTextual: aString
	self options: (self stringToCollection: aString default: self class defaultOptions).! !

!MASelectionDescription methodsFor: 'copying' stamp: 'lr 5/8/2005 20:32'!
postCopy
	super postCopy.
	self options: self options copy.! !

!MASelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
sorted
	^ self propertyAt: #sorted ifAbsent: [ self class defaultSorted ].! !

!MASelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
sorted: aBoolean
	self propertyAt: #sorted put: aBoolean.! !

MASelectionDescription subclass: #MASingleSelectionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASingleSelectionDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Single-Selection'! !

!MASingleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultNilLabel
	^ String new.! !

!MASingleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionNilLabel
	^ MAStringDescription selector: #nilLabel label: 'Nil Label' priority: 390.! !

!MASingleSelectionDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MASingleSelectionDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
allOptions
	^ Array streamContents: [ :stream |
		self isRequired 
			ifFalse: [ stream nextPut: nil ].
		stream nextPutAll: super allOptions ].! !

!MASingleSelectionDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject)
		and: [ self options includes: anObject ].! !

!MASingleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
nilLabel
	^ self propertyAt: #nilLabel ifAbsent: [ self class defaultNilLabel ].! !

!MASingleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:32'!
nilLabel: aString
	^ self propertyAt: #nilLabel put: aString.! !

MAElementDescription subclass: #MAStringDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAStringDescription subclass: #MAPasswordDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPasswordDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Password Field'! !

!MAPasswordDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isObfuscated: anObject
	^ anObject notNil
		and: [ anObject isString ] 
		and: [ anObject allSatisfy: [ :each | each = $* ] ].! !

!MAPasswordDescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
obfuscated: anObject
	^ String new: (self toString: anObject) size withAll: $*.! !

!MAStringDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Text Field'! !

!MAStringDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
kind
	^ String! !

MAStringDescription subclass: #MASymbolDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASymbolDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Symbol Field'! !

!MASymbolDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
kind
	^ Symbol! !

!MASymbolDescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:32'!
parseString: aString
	^ self parseString: aString protected: [ aString asSymbol ].! !

MAStringDescription subclass: #MATextDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATextDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Memo Field'! !

MAElementDescription subclass: #MATableDescription
	instanceVariableNames: 'rowLabels columnLabels cellDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATableDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Table'! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultCellDescription
	^ self defaultCellDescriptionClasses first new.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultCellDescriptionClasses
	^ Array 
		with: MAStringDescription
		with: MANumberDescription
		with: MABooleanDescription.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultColumnLabels
	^ OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultRowLables
	^ OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionCellDescription
	^ (MASingleSelectionDescription selector: #cellDescription label: 'Type' priority: 270 default: self defaultCellDescription)
		options: (self defaultCellDescriptionClasses collect: [ :each |
			each new
				label: each description label; 
				yourself ]);
		beRequired;
		yourself.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionColumnLabels
	^ MATextDescription selector: #columnLabelsTextual label: 'Column Labels' priority: 250.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionDefault
	^ nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionRequired
	^ nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionRowLabels
	^ MATextDescription selector: #rowLabelsTextual label: 'Row Labels' priority: 260.! !

!MATableDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
cellCount
	^ self columnCount * self rowCount.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
cellDescription
	cellDescription isNil
		ifTrue: [ self cellDescription: self class defaultCellDescription ].
	^ cellDescription.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
cellDescription: aDescription
	cellDescription := aDescription.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
columnCount
	^ self columnLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
columnLabels
	columnLabels isNil 
		ifTrue: [ self columnLabels: self class defaultColumnLabels ].
	^ columnLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
columnLabels: aCollection
	columnLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 5/8/2005 20:32'!
columnLabelsTextual
	^ self collectionToString: self columnLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 5/8/2005 20:32'!
columnLabelsTextual: aString
	^ self columnLabels: (self stringToCollection: aString default: self class defaultColumnLabels).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 5/8/2005 20:32'!
columnOfIndex: anInteger
	| index |
	index := anInteger \\ self columnCount.
	^ index isZero
		ifTrue: [ self columnCount ]
		ifFalse: [ index ].! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 5/8/2005 20:32'!
indexAt: aRowIndex at: aColIndex 
	^ ((aRowIndex - 1) * self columnCount) + aColIndex.! !

!MATableDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject)
		and: [ self cellCount = anObject size ].! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
kind
	^ SequenceableCollection! !

!MATableDescription methodsFor: 'copying' stamp: 'lr 5/8/2005 20:32'!
postCopy
	super postCopy.
	self rowLabels: self rowLabels copy.
	self columnLabels: self columnLabels copy.
	self cellDescription: self cellDescription copy.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
rowCount
	^ self rowLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
rowLabels
	rowLabels isNil 
		ifTrue: [ self rowLabels: self class defaultRowLables ].
	^ rowLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
rowLabels: aCollection
	rowLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 5/8/2005 20:32'!
rowLabelsTextual
	^ self collectionToString: self rowLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 5/8/2005 20:32'!
rowLabelsTextual: aString
	^ self rowLabels: (self stringToCollection: aString default: self class defaultRowLables).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 5/8/2005 20:32'!
rowOfIndex: anInteger
	^ anInteger - 1 // self columnCount + 1.! !

MAObject subclass: #MAMemento
	instanceVariableNames: 'model description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

MAMemento subclass: #MACachedMemento
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MACachedMemento class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MACachedMemento methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
commit: anObject
	super commit: anObject.
	self push: anObject.! !

!MACachedMemento methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
hasChanged
	^ self pull ~= self value.! !

!MACachedMemento methodsFor: 'private' stamp: 'lr 5/9/2005 13:31'!
reset: anObject
	super reset: anObject.
	self value: (self pull ifNil: [ self description default ]) asCachedCopy.! !

!MACachedMemento methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
setModel: aModel
	super setModel: aModel.
	self reset.! !

!MACachedMemento methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
value
	^ value! !

!MACachedMemento methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
value: anObject
	value := anObject! !

MACachedMemento subclass: #MACheckedMemento
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MACheckedMemento methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
commit: anObject
	super commit: anObject.
	self original: self value.! !

!MACheckedMemento methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
hasConflict
	^ self hasChanged
		and: [ self pull ~= self original ].! !

!MACheckedMemento methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
original
	^ original! !

!MACheckedMemento methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
original: anObject
	original := anObject! !

!MACheckedMemento methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' original: '; print: self original.! !

!MACheckedMemento methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
reset: anObject
	super reset: anObject.
	self original: self pull asCachedCopy.! !

!MACheckedMemento methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
validate: anObject
	super validate: anObject.
	self hasConflict ifTrue: [ 
		self 
			reset: anObject; 
			errorConcurrent ].! !

!MAMemento class methodsFor: 'instance creation' stamp: 'lr 5/9/2005 13:33'!
on: aDescription model: aModel
	^ self new
		setDescription: aDescription;
		setModel: aModel;
		yourself.! !

!MAMemento methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:31'!
= anObject
	^ self species = anObject species
		and: [ self model = anObject model ].! !

!MAMemento methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:30'!
accessor
	^ self description accessor.! !

!MAMemento methodsFor: 'actions' stamp: 'lr 5/9/2005 13:30'!
commit
	"Commit the value into the model."

	self description isReadonly
		ifTrue: [ ^ self ].
	self notifyCommitBefore.
	self commit: self value.
	self notifyCommitAfter.! !

!MAMemento methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
commit: anObject
	"Primitive to commit anObject to the model. Do not call directly, use #commit instead."! !

!MAMemento methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:30'!
description
	^ description! !

!MAMemento methodsFor: 'errors' stamp: 'lr 5/9/2005 13:31'!
errorConcurrent
	MAConcurrentError memento: self message: 'Concurrent modification in ' , self description asLabel.! !

!MAMemento methodsFor: 'errors' stamp: 'lr 5/9/2005 13:31'!
errorReadonly
	MAReadonlyError memento: self message: self description asLabel , ' is readonly.'.! !

!MAMemento methodsFor: 'errors' stamp: 'lr 5/9/2005 13:31'!
errorRequired
	MARequiredError memento: self message: self description asLabel , ' is required.'.! !

!MAMemento methodsFor: 'errors' stamp: 'lr 5/9/2005 13:31'!
errorValidation
	MAValidationError memento: self message: self description asLabel , ' is invalid.'.! !

!MAMemento methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:31'!
hash
	^ self species hash bitXor: self model hash.! !

!MAMemento methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
model
	^ model! !

!MAMemento methodsFor: 'notification' stamp: 'lr 5/8/2005 20:31'!
notifyCommitAfter
	MACommitNotification notifyAfter: self.! !

!MAMemento methodsFor: 'notification' stamp: 'lr 5/8/2005 20:31'!
notifyCommitBefore
	MACommitNotification notifyBefore: self.! !

!MAMemento methodsFor: 'notification' stamp: 'lr 5/8/2005 20:31'!
notifyResetAfter
	MAResetNotification notifyAfter: self.! !

!MAMemento methodsFor: 'notification' stamp: 'lr 5/8/2005 20:31'!
notifyResetBefore
	MAResetNotification notifyBefore: self.! !

!MAMemento methodsFor: 'notification' stamp: 'lr 5/8/2005 20:31'!
notifyValidateAfter
	MAValidateNotification notifyAfter: self.! !

!MAMemento methodsFor: 'notification' stamp: 'lr 5/8/2005 20:31'!
notifyValidateBefore
	MAValidateNotification notifyBefore: self.! !

!MAMemento methodsFor: 'copying' stamp: 'lr 5/9/2005 13:33'!
postCopy
	super postCopy.
	self setDescription: nil.! !

!MAMemento methodsFor: 'printing' stamp: 'lr 5/8/2005 20:31'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' value: '; print: self value.! !

!MAMemento methodsFor: 'private-model' stamp: 'lr 5/9/2005 13:31'!
pull
	"Primitive to read from the model. Do not call directly, use #value instead."

	^ self model readUsing: self description.! !

!MAMemento methodsFor: 'private-model' stamp: 'lr 5/9/2005 13:31'!
push: anObject
	"Primitive to write to the model. Do not call directly, use #value: instead."

	self model write: anObject using: self description.! !

!MAMemento methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
reset
	"Resets the value to the one of the model."
	
	self notifyResetBefore.
	self reset: self value.
	self notifyResetAfter.! !

!MAMemento methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
reset: anObject
	"Primitive to reset anObject. Do not call directly, use #reset instead."! !

!MAMemento methodsFor: 'initialization' stamp: 'lr 5/9/2005 13:32'!
setDescription: aDescription
	description := aDescription! !

!MAMemento methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:31'!
setModel: aModel
	model := aModel! !

!MAMemento methodsFor: 'actions' stamp: 'lr 5/9/2005 13:30'!
validate
	"Check if the value is valid within the model. In case of problems an exception is raised."

	self description isReadonly 
		ifTrue: [ ^ self ].
	self notifyValidateBefore.
	self validate: self value.
	self notifyValidateAfter.! !

!MAMemento methodsFor: 'private' stamp: 'lr 5/9/2005 13:31'!
validate: anObject
	"Primitive to validate anObject. Do not call directly, use #validate instead."
	
	(self description isRequired and: [ anObject isNil ])
		ifTrue: [ self errorRequired ].
	(anObject isNil or: [ self description isSatisfiedBy: anObject ])
		ifFalse: [ self errorValidation ].! !

!MAMemento methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:31'!
value
	self subclassResponsibility.! !

!MAMemento methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:31'!
value: anObject
	self subclassResponsibility.! !

MAMemento subclass: #MAStraitMemento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MAStraitMemento class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MAStraitMemento methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:51'!
value
	^ self pull ifNil: [ self description default ].! !

!MAStraitMemento methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
value: anObject
	self push: anObject.! !

!MAObject class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ true! !

!MAObject class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new.! !

!MAObject methodsFor: 'visiting' stamp: 'lr 5/8/2005 20:31'!
acceptMagritte: aVisitor! !

!MAObject methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
errorPropertyNotFound: aSelector
	self error: 'Property ' , aSelector , ' not found.'! !

!MAObject methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
hasProperties
	^ properties notNil
		and: [ properties notEmpty ].! !

!MAObject methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
inlcudesProperty: aKey
	^ self hasProperties
		and: [ self properties includesKey: aKey ].! !

!MAObject methodsFor: 'copying' stamp: 'lr 5/8/2005 20:31'!
postCopy
	super postCopy.
	properties := properties copy.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
properties
	properties isNil
		ifTrue: [ properties := Dictionary new ].
	^ properties.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey
	^ self propertyAt: aKey ifAbsent: [ self errorPropertyNotFound: aKey ].! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey ifAbsent: aBlock
	self hasProperties
		ifFalse: [ ^ aBlock value ].
	^ self properties at: aKey ifAbsent: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey ifAbsentPut: aBlock
	^ self properties at: aKey ifAbsentPut: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey put: aValue
	^ self properties at: aKey put: aValue.! !

MAObject subclass: #MARelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelation commentStamp: '<historical>' prior: 0!
I represent an immutable relation. Users usually want to check if the relation I am representing is satisfied by sending the message #isSatisfiedBy:!

MARelation subclass: #MABasicRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MABasicRelation subclass: #MAConstantRelation
	instanceVariableNames: 'value'
	classVariableNames: 'FalseRelation TrueRelation'
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAConstantRelation class methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
false
	^ FalseRelation! !

!MAConstantRelation class methodsFor: 'class initialization' stamp: 'lr 5/8/2005 20:33'!
initialize
	TrueRelation := self new
		setValue: true;
		yourself.
	FalseRelation := self new
		setValue: false;
		yourself.! !

!MAConstantRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAConstantRelation class methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
true
	^ TrueRelation! !

!MAConstantRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	^ super = anObject
		and: [ self value = anObject value ].! !

!MAConstantRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
hash
	^ super hash bitXor: self value hash.! !

!MAConstantRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isSatisfiedBy: anObject
	^ self value.! !

!MAConstantRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setValue: aBoolean
	value := aBoolean! !

!MAConstantRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
value
	^ value! !

MABasicRelation subclass: #MASelectorRelation
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MASelectorRelation subclass: #MAAccessorRelation
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAccessorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor
	^ accessor! !

!MAAccessorRelation methodsFor: 'testing' stamp: 'lr 5/9/2005 10:05'!
isSatisfiedBy: anObject
	| description |
	description := anObject descripition
		detect: [ :each | self accessor = each accessor ]
		ifNone: [ ^ false ].
	^ super isSatisfiedBy: (description read: anObject).! !

!MAAccessorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
setAccessor: anAccessor
	accessor := anAccessor! !

MASelectorRelation subclass: #MAQueryRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAQueryRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	^ super isSatisfiedBy: anObject query.! !

!MASelectorRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector
	^ self selector: aSelector arguments: Array new.! !

!MASelectorRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector arguments: aCollection
	^ self new
		setSelector: aSelector;
		setArguments: aCollection;
		yourself.! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector with: anObject
	^ self selector: aSelector arguments: (Array with: anObject).! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector with: aFirstObject with: aSecondObject
	^ self selector: aSelector arguments: (Array with: aFirstObject with: aSecondObject).! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
arguments
	^ arguments! !

!MASelectorRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSatisfiedBy: anObject
	^ anObject perform: self selector withArguments: self arguments.! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
selector
	^ selector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setArguments: aCollection
	arguments := aCollection! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setSelector: aSelector
	selector := aSelector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setSelector: aSelector argument: anObject
	self setSelector: (self selector , aSelector) asSymbol.
	self setArguments: (self arguments copyWith: anObject).! !

MARelation subclass: #MAComposedRelation
	instanceVariableNames: 'relations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MAComposedRelation subclass: #MAAllRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAllRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAAllRelation methodsFor: 'operators' stamp: 'lr 5/8/2005 20:29'!
& aRelation
	^ self copyWith: aRelation.! !

!MAAllRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isSatisfiedBy: anObject
	^ self relations allSatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

MAComposedRelation subclass: #MAAnyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAnyRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAAnyRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isSatisfiedBy: anObject
	^ self relations anySatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

!MAAnyRelation methodsFor: 'operators' stamp: 'lr 5/8/2005 20:29'!
| aRelation
	^ self copyWith: aRelation.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
new
	^ super new
		setRelations: Array new;
		yourself.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aRelation
	^ self withAll: (Array with: aRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aFirstRelation with: aSecondRelation
	^ self withAll: (Array with: aFirstRelation with: aSecondRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
withAll: anArray
	^ self new
		setRelations: anArray;
		yourself.! !

!MAComposedRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	^ super = anObject
		and: [ self relations = anObject relations ].! !

!MAComposedRelation methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
copyWith: aRelation
	^ self class withAll: (self relations copyWith: aRelation).! !

!MAComposedRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
hash
	^ super hash bitXor: self relations.! !

!MAComposedRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
relations
	^ relations! !

!MAComposedRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setRelations: aCollection
	relations := aCollection! !

MAComposedRelation subclass: #MANoneRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MANoneRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANoneRelation methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
!! aRelation
	^ self copyWith: aRelation.! !

!MANoneRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	^ self relations noneSatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 5/8/2005 20:31'!
!! aRelation
	^ MANoneRelation with: self with: aRelation.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 5/8/2005 20:31'!
& aRelation
	^ MAAllRelation with: self with: aRelation.! !

!MARelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:31'!
= anObject
	^ self species = anObject species.! !

!MARelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:31'!
hash
	^ self species hash.! !

!MARelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	self subclassResponsibility.! !

!MARelation methodsFor: 'operators-unary' stamp: 'lr 5/8/2005 20:31'!
not
	^ MANoneRelation with: self.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 5/8/2005 20:31'!
| aRelation
	^ MAAnyRelation with: self with: aRelation.! !

Object subclass: #MAScaffolder
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAScaffolder class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
description: aDescription
	^ self new
		description: aDescription;
		yourself.! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 6/7/2005 20:54'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [ values at: aMessage selector ifAbsent: nil ]
		ifFalse: [
			(aMessage selector isKeyword and: [ aMessage arguments size = 1 ])
				ifTrue: [ values at: aMessage selector allButLast put: aMessage argument ]
				ifFalse: [ super doesNotUnderstand: aMessage ] ].! !

!MAScaffolder methodsFor: 'initialization' stamp: 'lr 6/7/2005 20:55'!
initialize
	super initialize.
	values := IdentityDictionary new.! !

Object subclass: #MAVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAVisitor subclass: #MAStreamer
	instanceVariableNames: 'stream objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAStreamer subclass: #MAReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAReader methodsFor: 'streaming' stamp: 'lr 5/8/2005 20:31'!
next
	self subclassResponsibility.! !

MAReader subclass: #MAStReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAStreamer class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
on: aStream
	^ self new
		setStream: aStream;
		yourself.! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
id
	^ objects last key.! !

!MAStreamer methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
initialize
	super initialize.
	objects := OrderedCollection new.! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
object
	^ objects last value.! !

!MAStreamer methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setStream: aStream
	stream := aStream! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
stream
	^ stream! !

!MAStreamer methodsFor: 'visiting' stamp: 'lr 5/8/2005 20:32'!
visit: aFirstObject with: aSecondObject
	objects addLast: self nextId -> aSecondObject.
	[ self visit: aFirstObject ]
		ensure: [ objects removeLast ].! !

MAStreamer subclass: #MAWriter
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAWriter subclass: #MAStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAWriter methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:33'!
initialize
	super initialize.
	id := 0.! !

!MAWriter methodsFor: 'private' stamp: 'lr 5/8/2005 20:33'!
nextId
	^ 't' , (id := id + 1) asString.! !

!MAWriter methodsFor: 'streaming' stamp: 'lr 5/8/2005 20:33'!
nextPut: anObject
	self nextPut: anObject using: anObject description.! !

!MAWriter methodsFor: 'streaming' stamp: 'lr 5/8/2005 20:33'!
nextPut: anObject using: aDescription
	self visit: aDescription with: anObject.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 5/8/2005 20:33'!
visitBlockAccessor: anAccessor
	self stream 
		nextPutAll: anAccessor writeBlock decompile allButFirst allButLast; space; 
		nextPutAll: ' value: '; nextPutAll: self id;
		nextPutAll: ' value: '; nextPutAll: self id;
		nextPutAll: '.'; cr.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 5/8/2005 20:33'!
visitCacadeAccessor: anAccessor
	self visit: anAccessor accessor.
	self visit: anAccessor next.! !

!MAWriter methodsFor: 'visiting-descriptions' stamp: 'lr 5/8/2005 20:33'!
visitContainer: aDescription
	self stream nextPutAll: self id; nextPutAll: ' := '; nextPutAll: self object class name; nextPutAll: ' basicNew.'; cr.
	aDescription do: [ :each | 
		each isPersistent ifTrue: [
			self 
				visit: each
				with: (each accessor read: self object) ] ].! !

!MAWriter methodsFor: 'visiting-descriptions' stamp: 'lr 5/8/2005 20:33'!
visitElement: aDescription
	self stream 
		nextPutAll: self id; 
		nextPutAll: ' := '; 
		nextPutAll: aDescription class name; 
		nextPutAll: ' basicNew parseString: ';
		print: (aDescription toString: self object);
		nextPutAll: '.';
		cr.
	self nextPut: aDescription.
	self stream 
		nextPutAll: (aDescription accessor printWrite: self id to: objects allButLast last key);
		cr.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 5/8/2005 20:33'!
visitModelAccessor: anAccessor
	self error: anAccessor asString , ' is not implemented.'! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 5/8/2005 20:33'!
visitSelectorAccessor: anAccessor
	self stream nextPutAll: anAccessor writeSelector; space.! !

!MAVisitor methodsFor: 'visiting' stamp: 'lr 5/8/2005 20:33'!
visit: anObject
	anObject acceptMagritte: self.! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 5/8/2005 20:33'!
visitContainer: anObject
	self visitDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 5/8/2005 20:33'!
visitDescription: anObject! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 5/8/2005 20:33'!
visitElement: anObject
	self visitDescription: anObject.! !

!Object class methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ self name! !

!Object class methodsFor: '*Magritte-Core-accessing' stamp: 'lr 5/8/2005 20:29'!
description
	^ MACachedBuilder default build: self.! !

!Object methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asCachedCopy
	^ self shallowCopy.! !

!Object methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ self asString.! !

!Object methodsFor: '*Magritte-Core-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultContainer
	"Return the default description container."
	
	^ MAPriorityContainer new 
		label: self asLabel;
		yourself.! !

!Object methodsFor: '*Magritte-Core-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultWrapperClass
	^ MACheckedMemento! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 5/8/2005 20:29'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^ self class description.! !

!Object methodsFor: '*Magritte-Core-testing' stamp: 'lr 5/8/2005 20:29'!
isDescription
	^ false! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 5/8/2005 20:29'!
query
	"Return a string that represents that represents the receiver and is used as a default value for querying."

	^ self asString! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 5/8/2005 20:29'!
readUsing: aDescription
	"Dispatch the read-access to the receiver using the accessor of aDescription."

	^ aDescription accessor read: self.! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 5/8/2005 20:29'!
write: anObject using: aDescription
	"Dispatch the write-access to the receiver of anObject using the accessor of aDescription."

	aDescription accessor write: anObject to: self.! !

!False methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ 'no'! !

!SequenceableCollection methodsFor: '*Magritte-Core-moving' stamp: 'lr 5/8/2005 20:29'!
moveDown: anObject	
	| index |
	index := self 
		indexOf: anObject 
		ifAbsent: [ ^ self ].
	self swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!SequenceableCollection methodsFor: '*Magritte-Core-moving' stamp: 'lr 5/8/2005 20:29'!
moveUp: anObject	
	| index |
	index := self 
		indexOf: anObject 
		ifAbsent: [ ^ self ].
	self swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!Color methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/9/2005 17:27'!
asLabel
	self name isNil
		ifFalse: [ ^ self name ].
	^ String streamContents: [ :stream |
		stream nextPut: $#.
		stream nextPutAll: ((self red * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16).
		stream nextPutAll: ((self green * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16).
		stream nextPutAll: ((self blue * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16) ].! !

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject
	^ super realSubject value.! !

MAProxyObject subclass: #MAModelObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAModelObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject
	| context index |
	context := thisContext.
	[ context isNil ] whileFalse: [
		index := context receiver class 
			allInstVarNames indexOf: 'wrapper'.
		index isZero ifFalse: [ 
			^ super realSubject 
				value: (context receiver 
					instVarAt: index) model ].
		context := context sender ].
	^ nil.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
on: anObject
	^ self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
doesNotUnderstand: aMessage
	^ self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isMorph
	^ false! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isNil
	^ self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 5/8/2005 20:31'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 5/8/2005 20:31'!
printString
	^ String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject
	^ realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject: anObject
	realSubject := anObject! !

SmaCCParser subclass: #MARelationParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelationParser class methodsFor: 'generated-comments' stamp: 'lr 6/2/2005 12:01'!
parserDefinitionComment

	"Start
	: { nil }
	| Expression { #liftFirstValue: } 
	;


# E X P R E S S I O N S

Expression
	: OrExpression { #liftFirstValue: } 
	;

OrExpression
	: OrExpression 'expr1' ""OR"" AndExpression 'expr2' { MAAnyRelation with: expr1 with: expr2 }
	| AndExpression { #liftFirstValue: } 
	;

AndExpression
	: AndExpression 'expr1' ""AND"" NotExpression 'expr2' { MAAllRelation with: expr1 with: expr2 }
	| AndExpression 'expr1' NotExpression 'expr2' { MAAllRelation with: expr1 with: expr2 }
	| NotExpression { #liftFirstValue: } 
	;

NotExpression
	: ""NOT"" NotExpression 'expr' { MANoneRelation with: expr }
	| ""-"" NotExpression 'expr' { MANoneRelation with: expr }
	| ""("" Expression 'expr' "")"" { expr }
	| Relation { #liftFirstValue: } 
	; 


# R E L A T I O N S

Relation
	: Accessor 'accessor' UnaryMessage 'message' { self customize: message with: accessor } 
	| Accessor 'accessor' BinaryMessage 'message' { self customize: message with: accessor } 
	| Accessor 'accessor' KeywordMessage 'message' { self customize: message with: accessor }
	| LiteralValue 'literal' { MAQueryRelation selector: #matches: with: literal }
	;
	
Accessor
	: UnarySelector 'unary' { MASelectorAccessor selector: unary }
	;
	
UnaryMessage
	: UnarySelector 'unary' { MAAccessorRelation selector: unary }
	;
	
BinaryMessage
	: BinarySelector 'binary' LiteralValue 'literal' { MAAccessorRelation selector: binary with: literal }
	;
	
KeywordMessage
	: KeywordSelector 'keyword' LiteralValue 'literal' { MAAccessorRelation selector: keyword with: literal }
	| KeywordMessage 'message' KeywordSelector 'keyword' LiteralValue 'literal' { message setSelector: keyword argument: literal }
	;


# V A L U E S
	
UnarySelector
	: <unary> 'unary' { unary value asSymbol }
	;
	
BinarySelector
	: <binary> 'binary' { binary value asSymbol }
	;
	
KeywordSelector
	: <keyword> 'keyword' { keyword value asSymbol }
	;

LiteralValue
	: ""true"" { true }
	| ""false"" { false }
	| ""nil"" { nil }
	| <number> 'number' { number value asNumber }
	| <string> 'string' { string value copyFrom: 2 to: string value size - 1 }
	;"! !

!MARelationParser class methodsFor: 'generated-accessing' stamp: 'lr 6/2/2005 12:01'!
scannerClass
	^MARelationScanner! !

!MARelationParser class methodsFor: 'generated-starting states' stamp: 'lr 6/2/2005 12:01'!
startingStateForStart
	^1! !

!MARelationParser methodsFor: 'building' stamp: 'lr 5/8/2005 20:31'!
customize: aRelation with: anAccessor
	(MABlockToRelation includesSelector: aRelation selector) 
		ifFalse: [ self error: aRelation selector , ' is an unknown selector.' ].
	^ aRelation setAccessor: anAccessor.! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForAccessor1: nodes 
	^MASelectorAccessor selector: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForAndExpression1: nodes 
	^MAAllRelation with: (nodes at: 1) with: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForAndExpression2: nodes 
	^MAAllRelation with: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForBinaryMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForBinarySelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForKeywordMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForKeywordMessage2: nodes 
	^(nodes at: 1) setSelector: (nodes at: 2) argument: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForKeywordSelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForLiteralValue1: nodes 
	^true! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForLiteralValue2: nodes 
	^false! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForLiteralValue3: nodes 
	^nil! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForLiteralValue4: nodes 
	^(nodes at: 1) value asNumber! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForLiteralValue5: nodes 
	^(nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForNotExpression1: nodes 
	^MANoneRelation with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForNotExpression2: nodes 
	^MANoneRelation with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForNotExpression3: nodes 
	^nodes at: 2! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForOrExpression1: nodes 
	^MAAnyRelation with: (nodes at: 1) with: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForRelation1: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForRelation2: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForRelation3: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForRelation4: nodes 
	^MAQueryRelation selector: #matches: with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForStart1: nodes 
	^nil! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForUnaryMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/2/2005 12:01'!
reduceActionForUnarySelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-tables' stamp: 'lr 6/2/2005 12:01'!
reduceTable
	^#(
#(17 2 #reduceActionForRelation1:)
#(17 2 #reduceActionForRelation2:)
#(17 2 #reduceActionForRelation3:)
#(17 1 #reduceActionForRelation4:)
#(18 1 #reduceActionForUnaryMessage1:)
#(19 2 #reduceActionForBinaryMessage1:)
#(20 2 #reduceActionForKeywordMessage1:)
#(20 3 #reduceActionForKeywordMessage2:)
#(21 1 #reduceActionForLiteralValue1:)
#(21 1 #reduceActionForLiteralValue2:)
#(21 1 #reduceActionForLiteralValue3:)
#(21 1 #reduceActionForLiteralValue4:)
#(21 1 #reduceActionForLiteralValue5:)
#(22 1 #reduceActionForUnarySelector1:)
#(23 1 #reduceActionForBinarySelector1:)
#(24 1 #reduceActionForKeywordSelector1:)
#(25 2 #reduceActionForNotExpression1:)
#(25 2 #reduceActionForNotExpression2:)
#(25 3 #reduceActionForNotExpression3:)
#(25 1 #liftFirstValue:)
#(26 3 #reduceActionForAndExpression1:)
#(26 2 #reduceActionForAndExpression2:)
#(26 1 #liftFirstValue:)
#(27 3 #reduceActionForOrExpression1:)
#(27 1 #liftFirstValue:)
#(28 1 #reduceFor:)
#(29 0 #reduceActionForStart1:)
#(29 1 #liftFirstValue:)
#(32 1 #liftFirstValue:)
#(33 1 #reduceActionForAccessor1:)
)! !

!MARelationParser methodsFor: 'generated-tables' stamp: 'lr 6/2/2005 12:01'!
transitionTable
	^#(
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 61 26 65 27 69 29 110 30 73 32 77 33)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 81 25 77 33)
#(2 46 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 85 25 77 33)
#(2 42 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 38 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 61 26 65 27 89 32 77 33)
#(2 58 1 2 3 4 5 6 7 8 9 10 11 12 13 14 30)
#(2 50 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 54 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 82 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 18 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 122 10 13 14)
#(2 94 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 93 4 102 5 21 6 25 7 29 8 102 9 33 10 37 11 41 12 45 17 49 21 53 22 97 25 102 30 77 33)
#(3 101 5 118 9 118 30)
#(2 0 30)
#(2 114 30)
#(3 33 10 105 13 109 14 113 18 117 19 121 20 125 22 129 23 133 24)
#(2 70 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 74 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 137 9)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 141 25 77 33)
#(2 90 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 145 26 77 33)
#(2 66 2 6 7 11 12)
#(2 62 2 6 7 11 12)
#(2 6 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 10 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 14 1 14 2 14 3 14 4 14 5 14 6 14 7 14 8 14 9 14 10 14 11 14 12 105 13 149 24 14 30)
#(2 22 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 13 2 21 6 25 7 37 11 41 12 153 21)
#(3 13 2 21 6 25 7 37 11 41 12 157 21)
#(2 78 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 86 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 93 4 98 5 21 6 25 7 29 8 98 9 33 10 37 11 41 12 45 17 49 21 53 22 97 25 98 30 77 33)
#(3 13 2 21 6 25 7 37 11 41 12 161 21)
#(2 26 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 30 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 34 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
)! !

!UndefinedObject methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ 'n/a'! !

!Integer methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asFileSize
	#( 'B' 'KB' 'MB' 'GB' 'TB' 'PB' 'EB' 'ZB' 'YB' )
		inject: self
		into: [ :value :each |
			value < 1024
				ifFalse: [ value // 1024 ]
				ifTrue: [ ^ value asString , ' ' , each ] ].! !

Notification subclass: #MANotification
	instanceVariableNames: 'memento when'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MANotification subclass: #MACommitNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MANotification class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
afterToken
	^ #after! !

!MANotification class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
beforeToken
	^ #before! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
memento: aMemento when: aSelector
	^ self new
		memento: aMemento;
		when: aSelector;
		signal.! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
notifyAfter: aMemento
	^ self memento: aMemento when: self afterToken.! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
notifyBefore: aMemento
	^ self memento: aMemento when: self beforeToken! !

!MANotification methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:31'!
accessor
	^ self memento accessor.! !

!MANotification methodsFor: 'accessing-dynamic' stamp: 'lr 5/9/2005 13:53'!
description
	^ self memento description.! !

!MANotification methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isAfter
	^ self when = self class afterToken.! !

!MANotification methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isBefore
	^ self when = self class beforeToken.! !

!MANotification methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
memento
	^ memento! !

!MANotification methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
memento: aMemento
	memento := aMemento! !

!MANotification methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
when
	^ when! !

!MANotification methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
when: aSymbol
	when := aSymbol! !

MANotification subclass: #MAResetNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MANotification subclass: #MAValidateNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!True methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ 'yes'! !

!Behavior methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asCachedCopy
	^ self! !
MAConstantRelation initialize!
